> ## Documentation Index
> Fetch the complete documentation index at: https://docs.phala.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Batch check on-chain deployment allowance for all CVMs under an app



## OpenAPI

````yaml /openapi.json post /api/v1/apps/{app_id}/cvms/is-allowed
openapi: 3.1.0
info:
  title: Phala Cloud API
  version: 0.1.0
servers:
  - url: https://cloud-api.phala.com
security: []
tags:
  - name: CVMs
    description: Confidential Virtual Machine (CVM) lifecycle management on Phala Network
  - name: Apps
    description: App template management and CVM deployment from app blueprints
  - name: Webhooks
    description: Manage webhook endpoints and monitor delivery history
  - name: SSH Keys
    description: SSH public key management for CVM access
  - name: KMS
    description: >-
      Key Management Service — key derivation, on-chain anchoring, and
      inspection
  - name: Instance Types
    description: Available hardware configurations for CVM deployment
  - name: Attestations
    description: Remote attestation and TEE verification endpoints
paths:
  /api/v1/apps/{app_id}/cvms/is-allowed:
    post:
      tags:
        - Apps
      summary: Batch check on-chain deployment allowance for all CVMs under an app
      operationId: handle_app_cvms_is_allowed_api_v1_apps__app_id__cvms_is_allowed_post
      parameters:
        - name: app_id
          in: path
          required: true
          schema:
            type: string
            title: App Id
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AppCvmsBatchIsAllowedResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
components:
  schemas:
    AppCvmsBatchIsAllowedResponse:
      properties:
        is_onchain:
          type: boolean
          title: Is Onchain
          description: Whether this app uses on-chain KMS
        results:
          items:
            $ref: '#/components/schemas/CvmIsAllowedItem'
          type: array
          title: Results
        total:
          type: integer
          title: Total
          default: 0
        allowed_count:
          type: integer
          title: Allowed Count
          default: 0
        denied_count:
          type: integer
          title: Denied Count
          default: 0
        error_count:
          type: integer
          title: Error Count
          default: 0
        skipped_cvm_ids:
          items:
            type: integer
          type: array
          title: Skipped Cvm Ids
      type: object
      required:
        - is_onchain
      title: AppCvmsBatchIsAllowedResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    CvmIsAllowedItem:
      properties:
        cvm_id:
          type: integer
          title: Cvm Id
        app_contract_address:
          type: string
          title: App Contract Address
        compose_hash:
          type: string
          title: Compose Hash
        device_id:
          type: string
          title: Device Id
        compose_hash_allowed:
          type: boolean
          title: Compose Hash Allowed
        allow_any_device:
          type: boolean
          title: Allow Any Device
        device_id_allowed:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Device Id Allowed
        is_allowed:
          type: boolean
          title: Is Allowed
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
      type: object
      required:
        - cvm_id
        - app_contract_address
        - compose_hash
        - device_id
        - compose_hash_allowed
        - allow_any_device
        - is_allowed
      title: CvmIsAllowedItem
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError

````